#ifndef __FIELD_GROUP__
#define __FIELD_GROUP__


using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{   
   class FieldGroup : public GroupTemplate<Field, FieldAttribut>
   {
      public:
      
         FieldGroup(void) : GroupTemplate<Field, FieldAttribut>()
         {/* Ne rien faire de plus */}               
         FieldGroup(const string& _id) : GroupTemplate<Field, FieldAttribut>(_id)
         {/* Ne rien faire de plus */}
         
         void setAttributes(const THashAttributes& attr)
         {
            for (THashAttributes::ConstIterator it = attr.begin(); it != attr.end(); it++)
               if ((*it).first.compare(string("id"))) // Non prise en compte de l'identifiant lors de l'affectation des attributs.
                  this->setSAttribut((*it).first, (*it).second);
            
            return;
         }
                 
         virtual const char* getName(void) const {return ("FieldGroup"); }  
         
         void parse (XMLNode& _node)
         {
            string name = _node.getElementName();            
            THashAttributes attributes;
            std::cout << "Traitement de " << name << std::endl;
            
            /// PARSING GESTION DES ATTRIBUTS ///
            _node.getAttributes(attributes);  
            this->setAttributes(attributes);
            attributes.clear();
               
            /// PARSING POUR GESION DES ENFANTS
            if (!(_node.goToChildElement()))
               WARNING("Le groupe de champ ne contient pas d'enfant !");
            else
            {
               //////////////////////////////////////
               do { // Parcours des contexts pour traitement. 
                            
                  string name = _node.getElementName();
                  attributes.clear();
                  _node.getAttributes(attributes);  
                                 
                  if (name.compare("field_group") == 0)
                  { // Parsing pour les groupes de champs
                        
                     if (attributes.end() != attributes.find("id"))
                     {// Si l'identifiant est défini.
                        if (FieldGroup::HasObject(attributes["id"]))
                           WARNING("Dans le context actuel, un groupe de champ du même nom existe déjà, le second fera référence au premier par défaut !"); // TODO TODO
                        FieldGroup* fgroup =(FieldGroup*)&createGroup(attributes["id"]);
                        fgroup->parse(_node);
                     }
                     /*else
                        this->createGroup();*/

                        
                     continue;
                        
                  }
                  else if (name.compare("field") == 0)
                  { // Parsing pour les champs
                  
                     if (attributes.end() != attributes.find("id"))
                        if (Field::HasObject(attributes["id"]))
                           WARNING("Dans le context actuel, un champ du même nom existe déjà, le second fera référence au premier par défaut !");  // TODO TODO                
                  } 
                  else
                     WARNING("Un groupe de champs ne peut contenir qu'un champ ou un autre groupe de champs !");
                     
               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent  
            }
                                       
            return;
         }
         
         ~FieldGroup(void) 
         {/* Ne rien faire de plus */}   
         
   }; // class FieldGroup
     
   typedef FieldGroup FieldDefinition ;
   
}; // namespace XMLIOSERVER
   
#endif // __FIELD_GROUP__

