#ifndef __XMLIO_XML_PARSER__
#define __XMLIO_XML_PARSER__ 

// Utilisation de la STL
using std::string;

namespace XMLIOSERVER
{
   namespace XML
   {          
      using XMLIOSERVER::Context;
      
      class XMLParser
      {
         public : 
         
            static void Parse(XMLNode& _node)
            {
               THashAttributes attributes;
               
               do {                
                 // Traitement de l'identifiant
                  _node.getAttributes(attributes);
                            
                  if (attributes.end() == attributes.find("id"))
                  { WARNING("Le context ne sera pas traité car il n'est pas identifié !"); continue; }
                  
                  if( Context::HasObject(attributes["id"]))
                  { WARNING("Le context ne sera pas traité car il existe déjà un autre context possédant le même nom !"); continue; }
                  
                  Context::SetCurrentContext(attributes["id"]);
                  Context& context = Context::CreateObject(attributes["id"]);
                  
                  context.parse(_node);
                  attributes.clear();
                  
               } while (_node.goToNextElement());               
            }    
            
            static bool CLASS_TEST(const string& file = string("/local/testsuite/iodef_test.xml"), ostream& log = std::clog)
            {
               ifstream istr( file.c_str() , ifstream::in );
               XMLNode node = XMLNode::CreateNode(istr);
               XMLParser::Parse(node);
               log << "Nombre de contexts listés : " << Context::GetCurrentListObject().getSize() << " contre 2 attendus."<< std::endl;
               log << "Nombre de contexts listés : " << FieldGroup::GetCurrentListObject().getSize() << " contre 1 attendus."<< std::endl;
               log << "Test  XMLParser ... ok !" << std::endl;
               return (true);
            }
                 
      }; // class XMLParser     
   }; // namespace XML

};// namespace XMLIOSERVER


#endif // __XMLIO_XML_PARSER__ 
